/*
 * $Id: toshctl.h,v 1.4 2003/03/20 02:23:30 cws Exp $
 * Copyright (C) 2003 Chatchawan Wongsiriprasert
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef __TOSHCTL_H__
#define __TOSHCTL_H__

#include <map>
#include <string>
#include <sys/types.h>

class CToshVar;

class CToshCtlApp
{
    typedef std::map<std::string,CToshVar*> TOSHVAR_MAP;
    TOSHVAR_MAP m_VarMap;
    std::string m_AppName;
    
    int m_Argc;
    char ** m_Argv;
    
    bool m_OptShowAll;
    bool m_OptShowBin;
    bool m_OptShowName;
    bool m_OptShowValue;
    std::string m_OptSepChar;
    unsigned m_OptShowFmt;
    uid_t m_euid;
    
    int parseCmdLine();
    
    int parseVar(std::string& var_name,std::string& item_name,
                        std::string& var_value,const char* param) const;
                        
    void   showToshVar(const std::string& var_name,
                                const std::string& item_name,
                                const CToshVar* var) const;
    void   setToshVar(const std::string& var_name,
                                const std::string& item_name,
                                CToshVar* var,const std::string& value);                                
    void formatOutput(const std::string& var_name,
                                const std::string& item_name,
                                const std::string& value) const;
                                
    std::string initTosh();
                                
public:
    CToshCtlApp(int argc,char* argv[]);
    ~CToshCtlApp();
    
    int run();
    
    void usage();
    void showVersion();

    uid_t getStarupEUID() const { return m_euid; }
};

#endif
